Name:           foswiki
Version:        1.0.4
Release:        1%{?dist}
Summary:        Wiki engine written in perl

Group:          Applications/Internet
License:        GPLv2+
URL:            http://foswiki.sf.net
Source0:        http://downloads.sourceforge.net/%{name}/Foswiki-%{version}.tgz
Source1:        foswiki-httpd.conf
Source2:        foswiki-logrotate.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
Requires:       rcs
Requires:       perl(Algorithm::Diff)
Requires:       perl(CGI::Carp) >= 1.26
Requires:       perl(Config)
Requires:       perl(Cwd) >= 3.05
Requires:       perl(Data::Dumper) >= 2.121
Requires:       perl(Error)
Requires:       perl(File::Copy) >= 2.06
Requires:       perl(File::Find) >= 1.05
Requires:       perl(File::Spec) >= 3.05
Requires:       perl(FileHandle) >= 2.01
Requires:       perl(IO::File) >= 1.10
Requires:       perl(Text::Diff)
Requires:       perl(Time::Local) >= 1.11
# Optional
Requires:       perl(CGI::Session) >= 3.95
Requires:       perl(Archive::Tar)
Requires:       perl(Locale::Maketext::Lexicon)
Requires:       perl(Digest::SHA1)
Requires:       perl(Unicode::MapUTF8)
# Not available :
#Requires:       perl(Encode::compat)
#Requires:       perl(Lingua::EN::Sentence)
#Requires:       perl(Win32::Console)       --> Windows only

#Optional CPAN Modules
#Module     Preferred version     Description
#CGI::Cookie     >=1.24     Used for session support
#Digest::base            
#Digest::SHA1            
#Jcode           Used for I18N support with perl 5.6
#Locale::Maketext::Lexicon     >=0     Used for I18N support
#Net::SMTP     >=2.29     Used for sending mail
#Unicode::Map           Used for I18N support with perl 5.6
#Unicode::Map8           Used for I18N support with perl 5.6
#Unicode::MapUTF8           Used for I18N support with perl 5.6
#Unicode::String           Used for I18N support with perl 5.6
#URI           Used for configure

%description
TWiki is a flexible, powerful, and easy to use enterprise collaboration
platform. It is a Structured Wiki which can be used to run a project
development space, a document management system, a knowledge base, or any other
groupware tool, on an intranet or on the internet.


%prep
%setup -q -n Foswiki-%{version}
#rm -f data/_empty/WebPreferences.txt
#rm -f pub/TWiki/TinyMCEPlugin/tinymce/jscripts/tiny_mce/plugins/cleanup/editor_plugin.js
#rm -f pub/TWiki/TinyMCEPlugin/tinymce/jscripts/tiny_mce/plugins/inlinepopups/readme.txt
rm -f bin/.htaccess.txt
sed -i 's/\r//' tools/rewriteshbang.pl
sed -i 's/\r//' AUTHORS
chmod a+x tools/upgrade_emails.pl
sed -i -e 's|^#! perl -w|#! /usr/bin/perl -w|' tools/rewriteshbang.pl
sed -i -e 's|^#!perl|#! /usr/bin/perl -w|' tools/upgrade_emails.pl

# Temporary hack to workaround a perl(CGI) < 1.38 bug
#sed -i -e 's|^#!/usr/bin/perl -w|#! /usr/bin/perl -s|' bin/configure

# Remove included perl modules
rm -rf lib/CPAN

# Filter unwanted Requires:
cat << EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(Foswiki.*)/d' \
      -e '/perl(further)/d'   \
      -e '/perl(param)/d'     \
      -e '/perl(the)/d'       \
      -e '/perl(within)/d'    \
      -e '/perl(TWiki)/d'
EOF

%define __perl_requires %{_builddir}/Foswiki-%{version}/%{name}-req
chmod +x %{__perl_requires}

%build
# nothing to build


%install
rm -rf $RPM_BUILD_ROOT
# data      --> /var/lib/foswiki/data 
# pub       --> /var/lib/foswiki/pub
# working   --> /var/lib/foswiki/working
# bin       --> /usr/share/foswiki/bin
# lib       --> /usr/share/foswiki/lib
# locale    --> /usr/share/foswiki/locale
# templates --> /usr/share/foswiki/templates
# tools     --> /usr/share/foswiki/tools

# Shared datas
mkdir -p $RPM_BUILD_ROOT%{_datadir}/foswiki
cp -r bin locale lib templates tools $RPM_BUILD_ROOT%{_datadir}/foswiki/

# User datas
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/foswiki
#mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/foswiki/working
cp -r pub data working $RPM_BUILD_ROOT%{_localstatedir}/lib/foswiki/

# workaround a probable bug somewhere...
ln -s ../../../../%{_localstatedir}/lib/foswiki/pub $RPM_BUILD_ROOT/%{_datadir}/foswiki/pub
# Will this be needed too ?
#ln -s ../../../../%{_localstatedir}/lib/foswiki/data $RPM_BUILD_ROOT/%{_datadir}/foswiki/data
#ln -s ../../../../%{_localstatedir}/lib/foswiki/working $RPM_BUILD_ROOT/%{_datadir}/foswiki/working


# httpd conf
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/foswiki.conf

# foswiki conf
sed -e 's|$foswikiLibPath = "/absolute/path/to/your/lib";|$foswikiLibPath = "/usr/share/foswiki/lib";|' \
    bin/LocalLib.cfg.txt > $RPM_BUILD_ROOT%{_datadir}/foswiki/bin/LocalLib.cfg
rm bin/LocalLib.cfg.txt

sed -e "s|/var/www/foswiki|/var/lib/foswiki|" \
    -e "s|# \$Foswiki::cfg{PubDir} = .*$|\$Foswiki::cfg{PubDir} = '/var/lib/foswiki/pub';|" \
    -e "s|# \$Foswiki::cfg{TemplateDir} = .*$|\$Foswiki::cfg{TemplateDir} = '/usr/share/foswiki/templates';|" \
    -e "s|# \$Foswiki::cfg{DataDir} = .*$|\$Foswiki::cfg{DataDir} = '/var/lib/foswiki/data';|" \
    -e "s|# \$Foswiki::cfg{LocalesDir} = .*$|\$Foswiki::cfg{LocalesDir} = '/usr/share/foswiki/locale';|" \
    -e "s|# \$Foswiki::cfg{WorkingDir} = .*$|\$Foswiki::cfg{WorkingDir} = '/var/lib/foswiki/working';|" \
    -e "s|# \$Foswiki::cfg{DefaultUrlHost} = .*$|\$Foswiki::cfg{DefaultUrlHost} = 'http://localhost';|" \
    -e "s|# \$Foswiki::cfg{ScriptUrlPath} = .*$|\$Foswiki::cfg{ScriptUrlPath} = '/foswiki/bin';|" \
    -e "s|# \$Foswiki::cfg{PubUrlPath} = .*$|\$Foswiki::cfg{PubUrlPath} = '/foswiki/pub';|" \
    -e "s|^\$Foswiki::cfg{WebMasterEmail} = .*$|\$Foswiki::cfg{WebMasterEmail} = 'webmaster@example.com';|" \
    -e "s|^\$Foswiki::cfg{SafeEnvPath} = .*$|\$Foswiki::cfg{SafeEnvPath} = '/bin:/usr/bin';|" \
    -e "s|^\$Foswiki::cfg{ConfigurationLogName} = .*$|\$Foswiki::cfg{ConfigurationLogName} = '/var/log/foswiki/configurationlog.txt';|" \
    -e "s|^\$Foswiki::cfg{DebugFileName} = .*$|\$Foswiki::cfg{DebugFileName} = '/var/log/foswiki/debug.txt';|" \
    -e "s|^\$Foswiki::cfg{WarningFileName} = .*$|\$Foswiki::cfg{WarningFileName} = '/var/log/foswiki/warn%DATE%.txt';|" \
    -e "s|^\$Foswiki::cfg{LogFileName} = .*$|\$Foswiki::cfg{LogFileName} = '/var/log/foswiki/log%DATE%.txt';|" \
    -e "s|^\$Foswiki::cfg{MinPasswordLength} = .*$|\$Foswiki::cfg{MinPasswordLength} = 8;|" \
    lib/Foswiki.spec > $RPM_BUILD_ROOT%{_datadir}/foswiki/lib/LocalSite.cfg

# $Foswiki::cfg{Site}{CharSet} = 'iso-8859-1';

# logdir and logrotate conf
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/foswiki
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d/foswiki

# Move conf file into /etc
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/foswiki
mv $RPM_BUILD_ROOT/%{_datadir}/foswiki/lib/LocalSite.cfg $RPM_BUILD_ROOT/%{_sysconfdir}/foswiki
ln -s ../../../..%{_sysconfdir}/foswiki/LocalSite.cfg $RPM_BUILD_ROOT/%{_datadir}/foswiki/lib/LocalSite.cfg


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING COPYRIGHT LICENSE index.html INSTALL.html ReleaseHistory.html ReleaseNotes01x00.html UpgradeGuide.html
%config(noreplace) %{_sysconfdir}/httpd/conf.d/foswiki.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/foswiki
%dir %{_sysconfdir}/foswiki
%attr(644,apache,root) %config(noreplace) %{_sysconfdir}/foswiki/LocalSite.cfg
%{_datadir}/foswiki
%attr(-,apache,root) %{_localstatedir}/lib/foswiki
%attr(-,apache,root) %dir %{_localstatedir}/log/foswiki


%changelog
* Tue Mar 24 2009 Xavier Bachelot <xavier@bachelot.org> - 1.0.4-1
- Update to foswiki 1.0.4.

* Mon Mar 09 2009 Xavier Bachelot <xavier@bachelot.org> - 1.0.0-1
- Update to foswiki 1.0.0.

* Mon Nov 24 2008 Xavier Bachelot <xavier@bachelot.org> - 4.2.3-1
- Update to 4.2.3.

* Mon Feb 11 2008 Xavier Bachelot <xavier@bachelot.org> - 4.2.0-1
- Initial build.
